%{
#include <iostream.h>
#include <string>
#include "Oberon.Parser.tab.h"

int comment_recurs = 0;
%}

%option noyywrap   
/* ek het geen idee wat hierdie doen nie !!!  */
%x comment

DIGIT		       	[0-9]
ID              	[a-zA-Z_][_a-zA-Z0-9]*
OPERATOR				[+\-*/]
OPENCOMMENT			[(][*]
CLOSECOMMENT		[*][)]

%%

<INITIAL>[+]									{ return ADD_; }
<INITIAL>[>]									{ return GREAT_; }
<INITIAL>[<]									{ return LESS_; }
<INITIAL>[=]									{ return EQUAL_; }
<INITIAL>[#]									{ return NOTEQUAL_; }
<INITIAL>[<][=]								{ return LESSEQUAL_; }
<INITIAL>[>][=]								{ return GREATEQUAL_; }
<INITIAL>[\-]									{ return MIN_; }
<INITIAL>[*]									{ return MUL_; }
<INITIAL>[/]									{ return DIV_; }
<INITIAL>[~]									{ return TILDE_; }

<INITIAL>[;]									{ return SEMI_; }
<INITIAL>[:][=]								{ return ASSIGN_; }

<INITIAL>{DIGIT}+       					{ return INT_; }
<INITIAL>{DIGIT}+"."{DIGIT}+ 				{ return FLOAT_;}

<INITIAL>[.]									{ return DOT_;}
<INITIAL>[,]									{ return COMMA_;}
<INITIAL>[(]									{ return LEFT_ROUND_;}
<INITIAL>[)]									{ return RIGHT_ROUND_;}
<INITIAL>[:]									{ return COLON_; }

<INITIAL>IF										{ return IF_;}
<INITIAL>THEN									{ return THEN_;}
<INITIAL>ELSE									{ return ELSE_;}
<INITIAL>ELSIF									{ return ELSIF_; }
<INITIAL>BEGIN									{ return BEGIN_;}
<INITIAL>END									{ return END_;}
<INITIAL>WHILE									{ return WHILE_; }
<INITIAL>FOR									{ return FOR_;}
<INITIAL>REPEAT								{ return REPEAT_;}
<INITIAL>UNTIL 								{ return UNTIL_;}
<INITIAL>DO										{ return DO_;}
<INITIAL>MODULE								{ return MODULE_;}
<INITIAL>OR										{ return OR_; }
<INITIAL>TO										{ return TO_; }
<INITIAL>&										{ return AND_; }
<INITIAL>CONST									{ return CONST_; }
<INITIAL>VAR									{ return VAR_;}
<INITIAL>BOOLEAN								{ return BOOLEANTYPE_; }
<INITIAL>INTEGER								{ return INTEGERTYPE_; }
<INITIAL>REAL									{ return REALTYPE_; }


<INITIAL>{ID}           					{ 
														return ID_; 
													}


<INITIAL><<EOFF>>								{ return 0; }
<INITIAL>\n										;
<INITIAL>[ \t]									;

<INITIAL>{OPENCOMMENT}						{ 
														BEGIN(comment);
														comment_recurs = 0;
													}
<comment>{OPENCOMMENT}						{  comment_recurs++;	}	
<comment>{CLOSECOMMENT}						{ 	
														--comment_recurs;
														if (0==comment_recurs) BEGIN(INITIAL);	
													}
<comment>[^*\n]								;
<comment>[\n]									;
<comment><<EOF>>								{return 0;}

%%

