/***********************************************************************
  Pieter Breed     - 13093436                                          *
  RW354            - Werkstuk 3                                        *
  6 Oktober 2001                                                       *
                                                                       *
  bach.sun.ac.za:~/rw354/ws3/OberonC.cc                                *
  pantera.dagbreek.sun.ac.za:~/c++/rw354/ws3/OberonC.cc                *
                                                                       *
  Hierdie is 'n Oberon Compiler vir die P-masjien. Dit mag dalk net    *
  die mees oordraagbare kode genereer wat jy van weet. :)              *
***********************************************************************/


//*************** INCLUDES ******************************
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <FlexLexer.h>
#include "FlexBison/Oberon.Parser.tab.h"
#include "OutPutClass/OutPutClass.h"
#include "CodeGenerator/CodeGenerator.h"
#include <string.h>
//******************************************************


//*************** BISON ******************************
// Hierna volg net die truuks om bison te Object Orientate.
// Dit het basies tot gevolg dat bison nou soos 'n procedure
// werk maar my yylex en yyerror gebruik wat in die klasse
// FlexClass en Errors verklaar is.
//***************************************//
yyFlexLexer FlexClass;                   //
OutPutClass Out;                         //
#define yylex FlexClass.yylex            //
#define yyerror Out.Error                //
#define debug Out.Debug                  //
#include "FlexBison/Oberon.Parser.tab.c" //
#undef yylex                             //
#undef yyerror                           //
#undef debug                             //
//***************************************//


// *************** GLOBALS ******************************
// yyFlexLexer FlexClass;
// OutPutClass Out;
ifstream From;
ofstream To;
//*******************************************************


// *************** INIT *********************************
int init(int Argc, char* Argv[])
{
  // This switch, and the if after, tests for the input and output streams
  // It tries to read the input and output files as command line arguments
  // otherwise it uses stdin and stdout.
  switch (Argc) {
  case 1 : 
	 cout << "Using stdin as input file and stdout as output file." << endl;
	 FlexClass = yyFlexLexer();
	 break;
  case 2:
	 cout << "Too few arguments!\n\n";
	 cout << "SYNTAX: OberonC <inputfile> <outputfile>" << " or\n";
	 cout << "        OberonC " << endl;
	 return -1;
	 break;
  case 3:
	 cout << "Using " << Argv[1] << " as input file." << endl;
	 cout << "Using " << Argv[2] << " as output file." << endl;
	 From.open(Argv[1]);
 	 To.open(Argv[2]);
	 if (!From)
		{
		  cout << "Cannot open the input file : " << Argv[1] << endl;
		  return -1;
		}
	 if (!To)
		{
		  cout << "Cannot open the output file : " << Argv[2] << endl;
		  return -1;
		}
	 FlexClass = yyFlexLexer(&From);
	 break;
  default:
	 cout << "Too many arguments!\n\n";
	 cout << "SYNTAX: OberonC <inputfile> <outputfile>" << "\t or\n";
	 cout << "        <command> | OberonC" << endl;
	 return -1;
	 break;
  }


  Out.SetDebugOn();
  return 1;
}


//*************** MAIN ******************************
int main(int Argc, char* Argv[])
{
  int initresult = init(Argc, Argv);
  if (-1 == initresult) return -1;
  yyparse();
}
//*************** END ******************************
